:
# ptee.sh

USAGE="Usage: $0 [-ae] file cmd [arg...]"

TEEOPT=
TEE_STDERR=false

while [ $# != 0 ]; do
	case "$1" in
	--)
		shift; break;;
	-)
		break;;
	-*)
		OPTS="`expr \"$1\" : '.\(.*\)'`"; shift		
		while [ X"$OPTS" != X ]; do
			case "$OPTS" in
			a*)
				TEEOPT=-a;;
			e*)
				TEE_STDERR=true;;
			*)
				echo "$USAGE" 1>&2; exit 255;;
			esac
			OPTS="`expr \"$OPTS\" : '.\(.*\)'`"
		done;;
	*)
		break;;
	esac
done

case $# in
0|1)
	echo "$USAGE" 1>&2; exit 255;;
esac

OUTF="$1"; shift
if [ $TEE_STDERR = true ]; then
	exec "$@" 2>&1
else
	exec "$@"
fi | tee $TEEOPT "$OUTF"
